package fxPuntti;

import java.net.URL;
import java.util.ResourceBundle;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ListChooser;
import fi.jyu.mit.fxgui.ModalController;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import puntti.Liike;
import puntti.Puntti;
import puntti.SailoException;


/**
 * @author laspa
 * @version 20.1.2025
 *
 */
public class PunttiGUIController implements Initializable{
    
    @FXML private ListChooser<Liike> chooserLiikkeet;


    
    @Override
    public void initialize(URL url, ResourceBundle bundle) {
        alusta();
    }
    
    @FXML void handleDefaultTallenna() {
        Dialogs.showMessageDialog("Ei osata vielä tallentaa");
    }
    

    @FXML void handleDefaultApua() {
        Dialogs.showMessageDialog("Ei osata vielä");
    }

    @FXML void handleDefaultMuokkaa() {
        Dialogs.showMessageDialog("Ei osata vielä");
    }

    @FXML void handleDefaultPoistaTulos() {
        Dialogs.showMessageDialog("Ei osata poistaa tulosta");
    }

    @FXML void handleDefaultTiedosto() {
        Dialogs.showMessageDialog("Ei osata vielä");
    }

    @FXML void handleDefaultUusiLiike() {
        //ModalController.showModal(PunttiGUIController.class.getResource("LisaaUusiLiikeGUIView.fxml"), "Liike", null, "");
        uusiLiike();
    }

    @FXML private void handleUusiTulos() {
        ModalController.showModal(PunttiGUIController.class.getResource("LisaaUusiTulosGUIView.fxml"), "Tulos", null, "");
    }

    //___________________________________________________________________ ALLE JAVA
    
    
    
    
    /**
     * puntti mitä käytetään
     */
    private Puntti puntti;
    
    
    private void alusta() {
        chooserLiikkeet.clear();
    }
    
    private void lueTiedosto(@SuppressWarnings("unused") String nimi) {
//        punttinimi = nimi;
//        setTitle("Puntti - " + nimi);
        String virhe = "Ei ostata lukea vielä";
//        if (virhe != null)
            Dialogs.showMessageDialog(virhe);
    }
    
    /**
     * @return palauttaa true jos avataan ja false jos ei avata
     */
    public boolean avaa() {
        String uusinimi = KirjautumissivuGUIController.kysyNimi(null, "Vili");
        if (uusinimi == null) return false;
        lueTiedosto(uusinimi);
        return true;
    }
      


    /**
     * Asetetaan käytettävä puntti
     * @param puntti jota käytetään
     */
    public void setPuntti(Puntti puntti) {
        this.puntti = puntti;
        
    }
    
    
    private void hae(int lid) {
        chooserLiikkeet.clear();
        
        int index = 0;
        for (int i=0; i < puntti.getLiikkeita(); i++) {
            Liike liike = puntti.annaLiike(i);
            if(liike.getLid() == lid) index = i;
            chooserLiikkeet.add(""+liike.getNimi(), liike);
        }
        chooserLiikkeet.setSelectedIndex(index);
        
    }
    
    
    /**
     * Lisätään Punttiin uusi liike
     */
    private void uusiLiike() {
        Liike uusi = new Liike();
        uusi.lisaaLiike();
        uusi.taytaKyykky();
        try {
            puntti.lisaa(uusi);
        } catch (SailoException e) {
            Dialogs.showMessageDialog("Ounou ongelma lisätessä liikettä" + e.getMessage());
        }
        hae(uusi.getLid());
    }
    
   

}